#ifndef DSP_H
#define DSP_H

#include <string>
#include "control.h"
#include "queue.h"
#include "soundgen.h"
#include "tts.h"

class tts_engine;

class ssDspDevice {
  thread_ctl ctl;
  thread_ctl devLock;
  void *current;
  int fd;
  std::string devName;
  queue<tts_engine> lockSeq;
  soundGenerator *sd;
  int formats;
  double rateConvFactor;
  char *rateConvBufferp;
 public:
  ssDspDevice();
  ssDspDevice(char *);
  ~ssDspDevice();
  int write(const void *, size_t);
  int finish();
  int reset();
  int sync();
  int open();
  int close();
  void setDevName(char *);
  void reserveLock(tts_engine *const);
  void waitLock(tts_engine *const );
  void releaseLock(tts_engine *);
  void clearLock();
  void clearLock(void *);
  int playTone(const char *cmd_args);
};

#endif
